/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 #include "includes/controlBDD.h"
 
 
 ControlBDD *ControlBDD::instance = 0;
 
 ControlBDD::ControlBDD(string dbname):dbname(dbname) {
	 	db=new Database(dbname);

 }
 
ControlBDD* ControlBDD::getInstance() {
	 if (instance == NULL)
		 instance = new ControlBDD(BASE);
	 
	 return instance;
 }
	 
 /*Getters et Setters*/

string ControlBDD::getDbname(void) {
	return dbname;
}
void ControlBDD::setDbname(string dbname) {
	this->dbname = dbname;
}

/*Ouverture de la connexion à la base de donnée*/
bool ControlBDD::connexionDb(void) 
{	
	/*Connexion à la base de données ?*/
	
	if ((db)->Connected())
	{
		cout<<"Connexion établie a la base"<<endl;
		return true;
	}
		else
		{
			cout<<"Connexion a la base echoue"<<endl;
			return false;
		}
}

/*Execution d'une requete de type select et qui place les résultats dans un vecteur*/
vector<string>* ControlBDD::selectInDb(string requete) {
	
vector<string> *elts = new vector<string>() ;
int i=0;	
Query q (*db);
char query [256];
	/*On cree et initialse la requete*/
	try
	{
		
		sprintf(query,requete.c_str());
		
	
	/*On execute la requete */
		 q.get_result(query);
	}
	
	catch (exception& er) {
        cerr << "Error controlBDD 1: " << er.what() << endl;   
    }

	
	/*On parcours l'ensemble du Result Set*/
while (q.fetch_row())
    {
		/*Pour chaque champ, on récupére sa valeur et on l'insere dans le vecteur*/
	i=0;
	while( (q.is_null(i)==false) && (i!=-1))
		{
			string valeur=q.getstr(i);
			i++;
			if (valeur == "") i=-1;
			else elts->push_back(valeur); //insertion
			
		}
	}
	q.free_result();
	return elts;
}
	
/*Fermeture de la connexion à la base de données*/
void ControlBDD::closeConnexionDb(void) {
	//cout<<"Fermeture de la connexion à la base"<<endl;
}
