#ifndef _MESSAGE_H_
#define _MESSAGE_H_

#include <string>

#define METHOD "POST"
#define ENVOI_TYPE "broadcast" //variable de la requete http pr l'envoi de sms
#define CREDIT_TYPE "check_balance" //variable de la requete http pour connaitre son crédit
#define BIZROUTE "busi"



class Destinataire;
class Prestataire;

using namespace std;
	
/*Classe abstraite definissant les caracteristique de la requete HTTP et du message*/
class Message {

protected :

	string requeteHTTP;//La requete

	Destinataire *dest;
	Prestataire *prest;

	string message; //le SMS

	//*Methode privee de la classe seulement utilisé par la methode envoyer*/
	string construireEnteteHTTP(int querySize); //Formate l'entete de la requete HTTP
 	

public : 
	Message(Prestataire *prest,string message);

	string getMessage(void);
	void setMessage(string message);

	string getRequeteHTTP(void);
	void setRequeteHTTP(string requeteHTTP);

	string getEnteteHTTP(void);
	void setEnteteHTTP(string enteteHTTP);

	virtual void construireRequeteHTTPenvoi() =0; //Methode virtuelle pure Formate la requete pour l'envoi de sms (redefini ds les classe filles
	void envoyer(void); //Envoi le message

	virtual ~Message() {}
	
};

/*********************************************Utiltaires*****************************************/

//Converti un entier en string
string intToString(int value);

//traduit les caracteres non autorisé pr les parametre de resuete en hexa
string hexEncode(const unsigned char& c);

//Fct urlEncode (cf php par exemple)
string urlEncode(const string& s) ;


#endif
