#ifndef _PARAM_H_
#define _PARAM_H_

#include <iostream>
#include <string>

//BD Connection
#ifdef _OPENWRT
#define LCDF "/tmp/lcd"
#define BASE "/tmp/automate.db"
#define REP "/usr/automate/automate.db"
#define SAVE 1
#define SAVE_TIME 2
#define LASTHOUR 1
#define LOG 4
#define MODE "OPENWRT"
#endif

#ifdef _LINUX
#define LCDF "lcd"
#define BASE "automate.db"
#define REP "automate2.db"
#define SAVE 1
#define SAVE_TIME 1
#define LASTHOUR 0
#define LOG 62
#define MODE "LINUX"
#endif

#define PRESENTE true
#define DEBUG 0

using namespace std;


// class parameters
class param
{
private:
bool  boutton;  //button
string debut;   // timer debut
string fin;       // timer fin
short nb; // time elapse nb

public:

param(void);
param(bool,string,string,short);

//getter setter
bool get_button(void);
void set_button(short);

void set_init_timer(string);
string get_init_timer();

void set_end_timer(string);
string get_end_timer(void);

void set_nb(short);

// cout

void print(void);

};


// for the configuration of the automaton
class config
{

public:

string EXP;
string DEST;
string SMTP;

// K8055 ana input
short INP_TEMP; // temperature captor
short INP_TEMP_CARD; // temperature captor
short INP_TEMP_TYPE; // temperature captor
short INP_PH1;  // ph captor
short INP_PH1_CARD; // ph captor
short INP_PH2;  // ph captor
short INP_PH2_CARD; // ph captor



short STOP_PUMP; //input 1 button for stopping pump during 10 min
short STOP_SKIMMER; //input 2 button for stopping/enabling pump skimmer
short OSMOLATION;  //input captor for osmolation
short RESERV; //input captor in the reserve water
short HIGH;  // higher input captor => if enabled => skimer stopped and alert 
short OUTHQI;  //out 1
short OUTBLUE ;  // out 2
short OUTBLUE2;  // out 2
short OUTPUMP;  // out 3
short OUTPUMP2;
short OUTPREMONT; // water pump 
short OUTSKIMMER ;  // out 4
short OUTOSMOLATION ;// out 5
short OUTTEMP;// out 6
short OUTRAH ; // out 7
short OUTRAC;
short STOP_PUMP_CARD; //input 1 button for stopping pump during 10 min
short STOP_SKIMMER_CARD; //input 2 button for stopping/enabling pump skimmer
short OSMOLATION_CARD;  //input captor for osmolation
short RESERV_CARD; //input captor in the reserve water
short HIGH_CARD;  // higher input captor => if enabled => skimer stopped and alert 
short STOP_PREMONT; // captor for water pump
short OUTHQI_CARD;  //out 1
short OUTBLUE_CARD ;  // out 2
short OUTBLUE2_CARD ;  // out 2
short OUTPUMP_CARD;  // out 3
short OUTPUMP2_CARD;
short OUTSKIMMER_CARD;  // out 4
short OUTOSMOLATION_CARD ;// out 5
short OUTTEMP_CARD;// out 6
short OUTRAH_CARD ; // out 7
short OUTPERI[4] ; 
short OUTPERI_CARD[4] ;
short OUTPREMONT_CARD;
short OUTRAC_CARD;
short STOP_PREMONT_CARD; // captor for water pump

short TOSMOLATION;
double DEBIT; // flow of the evaporation top up pump
short OUTVENT; // out for a ventilator
short OUTVENT_CARD;
double TMAX; // > TMAX ventilator started else stopped 
double STARTHQI; // hqi are started after xxx min 
double THQI; // temperature over which hqi are stopped
short RAH_TYPE; // type 0 rah works x min every y min type 1 rah works x min after osmolation
short FLOW; // used iff a flowmeter is added in input 1 or 2
short FLOW_CARD;
double FLOWIMPULSE; // for flowmeter nb of impulses /L
int FLOWTYPE; // flowmeter can be used with top off or not
short LCD; // enable lcd
short LOGLCD; //enable log lcd
short PH; //for ph sensor
double PHMIN;
double PHMAX; // for rac
short SMS; //enable sms
short forced_hqi;
short forced_blue;
short forced_blue2;
short forced_pump;
short forced_pump2;
short forced_peri[4];
short forced_skimmer;
short forced_osmolation;
short forced_temp;
short forced_rah;
short forced_ventilator;
short forced_premont;
short forced_rac;
short CARD1; // address of card -1=> no card
short CARD2; // address of card -1=> no card
config(void);
};

#endif
