/*
  Name : peristatic.hpp
  Copyright : Sebastien SALVA
  Authors : Sebastien SALVA
  Description: file which contents functions to use a peristatic pump
*/

#ifndef _PERISTATIC_HPP_
#define _PERISTATIC_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Peristatic:public Objet
{
private:
short numb; // numb of "plage horaire"
string name;// for differencing grp pumps and peristatic pumps  
string nb; // used for printing nb of pump (1->4)
time_t rawtime;
time_t t_timer;
short stop;
bool stop_p;
short out;
short card;

  void forceState(short,K8055 &,config &);	//force the state of the peristatic pump
  void changeState (short,K8055 &,config &);//change the state of the peristatic pump
void bouttonApp ();//button for stopping the pump
  void stop10 (K8055 &,config &);//stop the pump for 10 min 
public:
  Peristatic(string nam,string n,short numbe,short o, short c){numb=numbe;nb=n;name=nam;out=o;card=c;init();}
  void init();

  
  short get_State(string,connexion  &);// getting state of peristatic pump (depends of 5 time elapses)
  void changing(short, short,K8055&,config&);//check the state of the peristatic pump
short getStop ();
  bool getStop_p ();

  void setStop(short);
  void setStop_p (bool);
};


#endif
