/*
  Name :temperature.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a temperature captor
*/

#ifndef _TEMPERATURE_HPP_
#define _TEMPERATURE_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Temperature:public Objet
{
private:
  
 
  void forceState(short,K8055 &,config &);	//force the state of the captor
  void stopper (K8055&,config&);	//stop the heating
  void start (K8055&,config&);	//start the heating	
public:

  Temperature(){init();}
  void init();		//initialize the temperature captor
  
  void tempState(connexion &c,double,K8055&,config &);	//check the state of the temp captor

};

#endif
