#include "includes/phsonde.hpp"

int AttachHandler(CPhidgetHandle PH, void *userptr)
{
	int serialNo;
	const char *name;

	CPhidget_getDeviceName (PH, &name);
	CPhidget_getSerialNumber(PH, &serialNo);
	if (DEBUG==1) printf("%s %10d attached!\n", name, serialNo);

	return 0;
}

int DetachHandler(CPhidgetHandle PH, void *userptr)
{
	int serialNo;
	const char *name;

	CPhidget_getDeviceName (PH, &name);
	CPhidget_getSerialNumber(PH, &serialNo);
	if (DEBUG==1) printf("%s %10d detached!\n", name, serialNo);

	return 0;
}

int ErrorHandler(CPhidgetHandle PH, void *userptr, int ErrorCode, const char *Description)
{
	if (DEBUG==1) printf("Error handled. %d - %s\n", ErrorCode, Description);
	*((bool *)userptr)=true;	
	return 0;
}

int PHChangeHandler(CPhidgetPHSensorHandle PH, void *userptr, double Value)
{
*((double *)userptr)=Value;	
return 0;
}


void phsonde::init() {
int status;

n=0;
ph=0.0;
pht=0.0;
error_ph=false;
first_error=true;
correction=0;
CPhidgetPHSensor_create(&ifkit); 
CPhidget_set_OnAttach_Handler((CPhidgetHandle)ifkit, AttachHandler, NULL);
CPhidget_set_OnDetach_Handler((CPhidgetHandle)ifkit, DetachHandler, NULL);
CPhidget_set_OnError_Handler((CPhidgetHandle)ifkit, ErrorHandler, &error_ph);
CPhidgetPHSensor_set_OnPHChange_Handler(ifkit, PHChangeHandler, &pht);
CPhidget_open((CPhidget*)ifkit, -1);

CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
if (status==0) 
	{
	ph_usb=false; if (DEBUG == 1) cout << "ph" << nb << " usb: non" <<  endl;
	CPhidget_close ((CPhidget*)ifkit);
        CPhidget_delete((CPhidget*)ifkit);
	//c.insert_log("pas de carte ph phidgets connectée");
	}
	else ph_usb=true;

    }



double phsonde::read_ph(connexion &c, K8055 &k)
                {
if (n == 0) {
	if (ph_usb==true)
	{
	 if ((error_ph==true)&&  (first_error==true)) //erreur
          {
		ph=-1;		
		c.insert_log("erreur lecture ph"+nb);send_mail("erreur lecture PH"+nb+" , sonde pas activée !!!",c);
first_error=false;
	  }
 	  
        else { //pas d'erreur    
		calibrez(c,k);
		error_ph=false;
        	first_error=true;
		ph=pht+correction;
		if (DEBUG == 1) cout << "ph usb: " << ph << "calibration: " << correction <<  endl;
		c.insert_current_ph(ph,nb);
	     }	                     
	}
	else //ph_usb=false carte analogic 2
	{
	calibrez(c,k);
	error_ph=false;
	first_error=true;
	ph=(k.readAnalog(out,card)*14.0)/255.0+correction;
	if (DEBUG == 1) cout << "ph" << nb << " analogique+calib: " << ph << "calibration: " << correction <<  endl;
	c.insert_current_ph(ph,nb);	
	}



}     
n++;
if (n==25) n=0;
return ph;   
         }
// calibrer sonde
void phsonde::calibrez(connexion &c, K8055 &k)
    {
        double lecture=0;
        double p=0;

        p = c.calibre_ph(nb);
        if (p!=0)
        {
	       if (DEBUG == 1) cout << "calibrage ph" << nb << endl;
	       if (ph_usb==true) CPhidgetPHSensor_getPH(ifkit,&lecture);
	       else lecture=(14.0*k.readAnalog(out,card))/255.0;
               correction=p-lecture;
      	       c.set_calibre(correction,nb);
	}		            
}

double phsonde::get_ph() {
                    
                    return ph;
                
                }

bool phsonde::get_error() {return error_ph;}
void phsonde::set_first_error(bool b) {first_error=b;}
bool phsonde::get_first_error(){return first_error;}
void phsonde::set_correction(double d) {correction=d;}
double phsonde::get_correction() {return correction;}

phsonde:: ~phsonde()
{
CPhidget_close ((CPhidget*)ifkit);
CPhidget_delete((CPhidget*)ifkit);

}
