#include "stdafx.h"
#include "cphidgetphsensor.h"
#include <math.h>
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CMAKEPACKET_BUF(PHSensor, outputPacket, outputPacketLen)

CFHANDLE(PHSensor,PH) double), void *userPtr)
ASGNFPTR(PHSensor,PH)

CPHIDGETDATA(PHSensor)
	double E, E0, C, T=(273.15)+20, Vad;
	const double R=8.31441, N=1, F=96484.6;

	TESTPTR(phid)
	
	/* for now, assuming 20 celcius */

	/* calculate Ph */
	/* this should give a voltage between 0-5 as seen by the A/D */
	Vad = ((double)((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8))) / 13104.0;
	C = 2.3 * ((R*T)/(N*F));
	E0 = 7*C;
	E = (2.5 - Vad) / 4.745;
	phid->PH = (E0 - E) / C;
	phid->Potential = Vad;
	
	if (fabs(phid->PH - phid->lastPH) >= phid->PHChangeTrigger)
	{
		phid->lastPH = phid->PH;
		if (phid->fptrPHChange)
		{
			phid->fptrPHChange(phid, phid->fptrPHChangeptr, phid->lastPH);
		}
	}
	return EPHIDGET_OK;
}

CGET(PHSensor,PH,double)
	TESTPTRS(phid,pVal) 
	MASGN(PH)
}

CGET(PHSensor,Potential,double)
	TESTPTRS(phid,pVal) 
	MASGN(Potential)
}

CGET(PHSensor,PHChangeTrigger,double)
	TESTPTRS(phid,pVal) 
	MASGN(PHChangeTrigger)
}

CSET(PHSensor,PHChangeTrigger,double)
	TESTPTR(phid) 
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(Trigger, "%lf")
	else
		phid->PHChangeTrigger = newVal;
	return EPHIDGET_OK;
}

CPHIDGETINIT(PHSensor)
	phid->PH = -20;
	phid->lastPH = -20;
	phid->PHChangeTrigger = 0.5;
	return EPHIDGET_OK;
}

CCREATE(PHSensor, PHIDDEF_PHSENSOR)
