#include "stdafx.h"
#include "cphidgetstepper.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CSENDPACKET_BUF(Stepper, outputPacket, outputPacketLen)
CMAKEPACKET_BUF(Stepper, outputPacket, outputPacketLen)

int set_motor(CPhidgetStepperInfo *phid, int Index)
{
	unsigned char buffer[20];
	unsigned int temp1;
	long long i;

	buffer[0] = 0;

	if (!CPhidget_isAttached(&phid->phid))
		return EPHIDGET_NOTATTACHED;

	/* newer unipolar and bipolar steppers */
	if ((phid->phid.deviceVersion >= 100) && (phid->phid.deviceVersion < 200))
	{
	
		//old protocol
#if 0
		temp1 = (unsigned int)((phid->motorSpeedDesired[Index] * 4095) / 100.0);
		buffer[0] = ((unsigned char)Index << 4) | ((unsigned char)(temp1 >> 8));
		buffer[1] = (unsigned char)(temp1 & 0xff);
		temp1 = (unsigned int)((phid->motorAcceleration[Index] * 255) / 100.0);
		buffer[2] = (unsigned char)temp1;
		/* TODO: if we multiply by 8 first we add 3 decimal bits for microstepping (8 microsteps) */
		i = ((long long)phid->motorPositionDesired[Index]) + 0x8000000000LL;
		buffer[3] = (unsigned char)(i >> 32);
		buffer[4] = (unsigned char)(i >> 24);
		buffer[5] = (unsigned char)(i >> 16);
		buffer[6] = (unsigned char)(i >> 8);
		buffer[7] = (unsigned char)i;
#endif

		buffer[0] = (Index << 5) & 0xe0;
		
		i = ((long long)phid->motorPositionDesired[Index]);// + 0x10000000000LL;

		buffer[0] |= ((unsigned char)(i >> 35) & 0x3f);
		buffer[1] = (unsigned char)(i >> 27);
		buffer[2] = (unsigned char)(i >> 19);
		buffer[3] = (unsigned char)(i >> 11);
		buffer[4] = (unsigned char)(i >> 3);
		buffer[5] = ((unsigned char)(i << 5) & 0xe0);
		
		temp1 = (unsigned int)((phid->motorSpeedDesired[Index] * 4095) / 100.0);
		buffer[5] = ((unsigned char)(temp1 >> 8) & 0x0F);
		buffer[6] = (unsigned char)(temp1);
		
		temp1 = (unsigned int)((phid->motorAcceleration[Index] * 255) / 100.0);
		buffer[7] = (unsigned char)temp1;
		
		//printf("here is the position: double:%lf, long:%ld\n",phid->motorPositionDesired[Index],i);
		//printf("sizeof long: %d sizeof double: %d sizeof int: %d\n",sizeof(long long), sizeof(double), sizeof(int));
		//printf("%x %x %x %x\n", 
		//printf("%2x %2x %2x %2x \n", buffer[0], buffer[1], buffer[2], buffer[3]);
		//printf("%x %x %x %x\n", phid->motorPWMDesired[Index], (phid->motorPWMDesired[Index] * 64) / 100, (((phid->motorPWMDesired[Index] * 64) / 100) << 1), (unsigned char)(((phid->motorPWMDesired[Index] * 64) / 100) << 1));

		return _sendpacket(phid, buffer, 8);
	}
	else return EPHIDGET_UNEXPECTED;
	/* We need to remember to scale motorAcceleration from 0-100 to 0-255 */
}


CFHANDLE(Stepper,Input) int, int), void *userPtr)
ASGNFPTR(Stepper,Input)

CFHANDLE(Stepper,Position) int, long long), void *userPtr)
ASGNFPTR(Stepper,Position)

CFHANDLE(Stepper,Speed) int, double), void *userPtr)
ASGNFPTR(Stepper,Speed)

CPHIDGETDATA(Stepper)
	int index,speed;
	long long posn;
	double speed_d;

	TESTPTR(phid)
#if 0
	index = buffer[1] & 0x03;

	posn = (((unsigned long long)buffer[3]) << 32) +
		(((unsigned long long)buffer[4]) << 24) +
		(((unsigned long long)buffer[5]) << 16) +
		(((unsigned long long)buffer[6]) << 8) +
		(((unsigned long long)buffer[7]));

		cd Dposn = (posn - 0x8000000000LL);

	if (phid->motorPositionCurrent[index] != posn)
	{
		phid->motorPositionCurrent[index] = posn;
		FIRE(Position) index, posn);
	}

	speed = (((signed char)(buffer[1] & 0xFC)) << 6) | buffer[2];

	speed_d = (((speed) * 100.0) / 4095.0);

	if (phid->motorSpeedCurrent[index] != speed_d)
	{
		phid->motorSpeedCurrent[index] = speed_d;
		FIRE(Speed) index, speed_d);
	}
#endif
	index = (buffer[0]>>5) & 0x03;

	posn = (((((unsigned long long)buffer[0]) << 35) & 0x3f) +
		(((unsigned long long)buffer[1]) << 27) +
		(((unsigned long long)buffer[2]) << 19) +
		(((unsigned long long)buffer[3]) << 11) +
		(((unsigned long long)buffer[4]) << 3) +
		(((unsigned long long)buffer[5]) >> 5));

	//posn = (posn - 0x10000000000LL);
	
	if (phid->motorPositionCurrent[index] != posn)
	{
		phid->motorPositionCurrent[index] = posn;
		FIRE(Position) index, posn);
	}

	speed = (((signed char)((buffer[5] & 0x1f) << 3 )) << 5) | buffer[6];

	speed_d = (((speed) * 100.0) / 4095.0);

	if (phid->motorSpeedCurrent[index] != speed_d)
	{
		phid->motorSpeedCurrent[index] = speed_d;
		FIRE(Speed) index, speed_d);
	}
	
	return EPHIDGET_OK;
}

CGETINDEX(Stepper,InputState,int)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.stepper.numInputs)
	MASGN(inputStates[Index])
}


CGET(Stepper,NumMotors,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.stepper.numMotors)
}
CGET(Stepper,NumInputs,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.stepper.numInputs)
}
CGETINDEX(Stepper,Acceleration,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.stepper.numMotors)
	MASGN(motorAcceleration[Index])
}

CSETINDEX(Stepper,Acceleration,double)
	int ret;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.stepper.numMotors)
	if ((newVal > 100) || (newVal < 0)) return EPHIDGET_INVALIDARG;	
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Acceleration, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->motorAcceleration[Index] = newVal;
		ret = set_motor(phid, Index);
		CThread_mutex_unlock(&phid->phid.writelock);
	}
	return ret;
}

CGETINDEX(Stepper,MotorSpeed,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.stepper.numMotors)
	MASGN(motorSpeedCurrent[Index])
}

CSETINDEX(Stepper,MotorSpeed,double)
	int ret;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.stepper.numMotors)
	if ((newVal > 100) || (newVal < 0)) return EPHIDGET_INVALIDARG;	
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Velocity, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->motorSpeedDesired[Index] = newVal;
		ret = set_motor(phid, Index);
		CThread_mutex_unlock(&phid->phid.writelock);
	}
	return ret;
}

CGETINDEX(Stepper,MotorPosition,long long)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.stepper.numMotors)
	MASGN(motorPositionCurrent[Index])
}

CSETINDEX(Stepper,MotorPosition,long long)
	int ret;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.stepper.numMotors)
	if ((newVal > 549755813887LL) || (newVal < -549755813887LL)) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Position, "%d")
	else
	{	
		CThread_mutex_lock(&phid->phid.writelock);
		phid->motorPositionDesired[Index] = newVal;
		ret = set_motor(phid, Index);
		CThread_mutex_unlock(&phid->phid.writelock);
	}
	return ret;
}

CPHIDGETINIT(Stepper)
	int i;
	for (i = 0; i<phid->phid.attr.stepper.numMotors; i++) {
		phid->motorAcceleration[i] = 10;
		phid->motorSpeedDesired[i] = 25;
	}
	return EPHIDGET_OK;
}
CCREATE(Stepper, PHIDDEF_STEPPER)
