#include "stdafx.h"
#include "cphidgetweightsensor.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"
#include <math.h>

CMAKEPACKET_BUF(WeightSensor, outputPacket, outputPacketLen)

CFHANDLE(WeightSensor,Weight) double), void *userPtr)
ASGNFPTR(WeightSensor,Weight)

CPHIDGETDATA(WeightSensor)
	TESTPTR(phid)

	phid->Weight = ((double)((signed short)((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8)))) / 100.0 - 40.0;
	if (fabs(phid->Weight - phid->lastweight) >= phid->WeightChangeTrigger)
	{
		phid->lastweight = phid->Weight;
		if (phid->fptrWeightChange)
		{
			phid->fptrWeightChange(phid, phid->fptrWeightChangeptr, phid->lastweight);
		}
	}
	return EPHIDGET_OK;
}

CGET(WeightSensor,Weight,double)
	TESTPTRS(phid,pVal) 
	MASGN(Weight)
}
CGET(WeightSensor,WeightChangeTrigger,double)
	TESTPTRS(phid,pVal) 
	MASGN(WeightChangeTrigger)
}

CSET(WeightSensor,WeightChangeTrigger,double)
	TESTPTR(phid) 
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(Trigger, "%lf")
	else
		phid->WeightChangeTrigger = newVal;
	return EPHIDGET_OK;
}

CPHIDGETINIT(WeightSensor)
	phid->Weight = -500;
	phid->lastweight = -500;
	phid->WeightChangeTrigger = 5;
	return EPHIDGET_OK;
}

CCREATE(WeightSensor, PHIDDEF_WEIGHTSENSOR)
