// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#ifndef __STDAFX
#define __STDAFX

#include <stdio.h>
#include <stdlib.h>
#ifdef WINCE
int errno;
#define strerror(err) "strerror() Not Supported in Windows CE"
#define abort() exit(1)
#else
#include <sys/types.h>
#include <errno.h>
#endif


//#define malloc phi_malloc

#define WARN(...) (fprintf(stderr, "PHIDGET21: " __VA_ARGS__), fprintf(stderr, \
    "\n"), fflush(stderr), (void)0)

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#ifdef _WINDOWS
// Defines & Include for Windows only

	// Modify the following defines if you have to target a platform prior to the ones specified below.
	// Refer to MSDN for the latest info on corresponding values for different platforms.
	#ifndef WINVER				// Allow use of features specific to Windows XP or later.
	#define WINVER 0x0501		// Change this to the appropriate value to target other versions of Windows.
	#endif

	#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
	#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
	#endif						

	#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
	#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
	#endif

	#ifndef _WIN32_IE			// Allow use of features specific to IE 6.0 or later.
	#define _WIN32_IE 0x0600	// Change this to the appropriate value to target other versions of IE.
	#endif

	#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
	// Windows Header Files:
	#include <winsock2.h>
	#include <ws2tcpip.h>
#ifndef WINCE
	#include <Wspiapi.h>
#endif
	#include <windows.h>
	#include <winbase.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <time.h>
	#include <assert.h>
	#include "snprintf.h"
	#include "wincompat.h"

	#define strdup _strdup

	//#define CCONV __cdecl
	#define CCONV __stdcall
	#define SLEEP(dlay) Sleep(dlay);
	#define ZEROMEM(var,size) ZeroMemory(var, size);

	#ifdef PHIDGET21_EXPORTS
	#ifndef PHIDGET21_API
	#define PHIDGET21_API 
	#endif
	#else
	#ifndef PHIDGET21_API
	#define PHIDGET21_API __declspec(dllimport)
	#endif
	#endif
	
	typedef SYSTEMTIME TIME;
	
#else
// Defines & Include for both Mac and Linux
	#include <semaphore.h>
	#include <time.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <pthread.h>
	#include <errno.h>
	#include <sys/types.h>
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <arpa/inet.h>
	#include <netdb.h>
	#include <unistd.h>
	#include <sys/time.h>
	#include <ctype.h>

	#define CCONV
	#define SLEEP(dlay) usleep(dlay*1000);
	#define ZEROMEM(var,size) memset(var, 0, size);
	#ifndef PHIDGET21_API
	#define PHIDGET21_API
	//typedef sem_t CRITICAL_SECTION;
	typedef void *HANDLE;
	#define INFINITE 0xFFFFFFFF
	typedef long *LPDWORD;
	#define STILL_ACTIVE 0x00000103L
	#define WAIT_TIMEOUT 258L
	#define WAIT_OBJECT_0 0x00000000L
	
	typedef struct timeval TIME;
	
#endif

#ifdef _MACOSX
// Defines & Include for Mac only
#include <CoreFoundation/CoreFoundation.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/IOCFPlugIn.h>
#include <IOKit/usb/IOUSBLib.h>
#include <mach/mach.h>

#elif _LINUX
// Defines & Include for Linux Only
#include "libusb/usb.h"
#include <assert.h>

#endif
#endif

#ifdef DEBUG /*defined in the command line*/


/*void * phidget_malloc(size_t size, const char *file, int line);
void phidget_free(void *ptr, const char *file, int line);

#define malloc(size) phidget_malloc(size,__FILE__,__LINE__)
#define free(ptr) phidget_free(ptr,__FILE__,__LINE__)

#define Malloc malloc
#define Free free*/
#define DPRINT(...) ( printf("%s+%d: ", __FILE__, __LINE__), \
    printf(__VA_ARGS__), printf("\n"), fflush(stdout), (void)0 )
#else
#define DPRINT(...)
#endif


#include "pdictclient.h"
#include "cphidget.h"

#endif


